package Network;

import Network.Representation.*;
import Network.Algorithm.*;
import Network.Algorithm.SimplexAlgorithm.*;
import Network.Algorithm.FlowAugmentingDecreasingPathsAlgorithm.*;

import java.util.*;

public class NetworkTest {
    
    public static void main(String[] args){
        
        double perturb=Math.pow(2,0.5)/10000;
        perturb=0;
        
        World map=new World();
        ArcFactory factory=new ArcFactory(3,2);
        
        
        City c1=new City("c1",40); City c2=new City("c2",50);City c3=new City("c3",0);City c4=new City("c4",-30);City c5=new City("c5",-60);
        Road r12=new Road(3.0+perturb,100);
        Road r13=new Road(7.0+perturb,10);
        Road r14=new Road(5.0+perturb,35);
        Road r23=new Road(2.0+perturb,60); 
        Road r25=new Road(1.0+perturb,30);
        Road r35=new Road(8.0+perturb,100); 
        Road r45=new Road(4.0+perturb,100);
        
        map.addNode(c1);map.addNode(c2);map.addNode(c3);map.addNode(c4);map.addNode(c5);
        map.addArc(r12,c1,c2);
        map.addArc(r13,c1,c3);map.addArc(r14,c1,c4);map.addArc(r23,c2,c3);map.addArc(r25,c2,c5);
        map.addArc(r35,c3,c5);map.addArc(r45,c4,c5);
        
        
        NetworkImplementation map2=new NetworkImplementation();
        City n1=new City("n1",30); City n2=new City("n2",-20); City n3=new City("n3",-10);
        Road a12=new Road(5,26); Road a13=new Road(3,5); Road a23=new Road(4,50);
        map2.addNode(n1);map2.addNode(n2);map2.addNode(n3);
        map2.addArc(a13,n1,n3); map2.addArc(a12,n1,n2);map2.addArc(a23,n2,n3);
       
        
        NetworkImplementation map3=new NetworkImplementation();
        City s1=new City("s1",0);   City s2=new City("s2",0);   City s3=new City("s3",-6);  City s4=new City("s4",-6);
        City s5=new City("s5",-2);  City s6=new City("s6",9);   City s7=new City("s7",5);
        
        Road y13=new Road(48,50);   Road y14=new Road(28,50);   Road y15=new Road(10,50);   Road y21=new Road(7,50);
        Road y23=new Road(65,50);   Road y25=new Road(7,50);    Road y42=new Road(38,50);   Road y45=new Road(15,50);
        Road y61=new Road(56,50);   Road y62=new Road(48,50);   Road y63=new Road(108,50);  Road y67=new Road(24,50);
        Road y72=new Road(33,50);   Road y75=new Road(19,50);
        
        /*map3.addNode(s1);   map3.addNode(s2);   map3.addNode(s3);   map3.addNode(s4);   map3.addNode(s5);   map3.addNode(s6);   map3.addNode(s7);
        map3.addArc(y13,s1,s3); map3.addArc(y14,s1,s4); map3.addArc(y15,s1,s5); map3.addArc(y21,s2,s1);
        map3.addArc(y23,s2,s3); map3.addArc(y25,s2,s5); map3.addArc(y42,s4,s2); map3.addArc(y45,s4,s5);
        map3.addArc(y61,s6,s1); map3.addArc(y62,s6,s2); map3.addArc(y63,s6,s3); map3.addArc(y67,s6,s7);
        map3.addArc(y72,s7,s2); map3.addArc(y75,s7,s5); */
        
        
        
        
        SimplexAlgorithm mySimplex=new SimplexAlgorithm();
        FlowAugmentingDecreasingPathsAlgorithm myFlowAugment=new FlowAugmentingDecreasingPathsAlgorithm();
        mySimplex.setTargetNetwork(map);
        myFlowAugment.setTargetNetwork(map);
        try {mySimplex.solve(1e5,4,3);} catch (InfeasibleException e) {System.out.println("infeasible: " + e);}
        myFlowAugment.findFlowAugmentingPaths(mySimplex,c5,1e5,.1);
        myFlowAugment.findFlowDecreasingPaths(mySimplex,c5,1e5,.1);
        
        SimplexAlgorithm mySimplex2 = new SimplexAlgorithm();
        mySimplex2.setTargetNetwork(map2,true);
        FlowAugmentingDecreasingPathsAlgorithm myFlowAugment2=new FlowAugmentingDecreasingPathsAlgorithm();
        myFlowAugment2.setTargetNetwork(map2,true);
        System.out.println("Solving network map2.");
        try {mySimplex2.solve(1e5,3,3);} catch (InfeasibleException e) {System.out.println("infeasible:" + e);}
        myFlowAugment2.findFlowAugmentingPaths(mySimplex2,n3,1e5,0);
        
        mySimplex.setTargetNetwork(map);
        System.out.println("this is the end");
        
        /*TreeAlgorithm myTree=new TreeAlgorithm();
        myTree.setTargetNetwork(map3,false);
        myTree.getAlgNodeInfo(s1).treePredecessor=null;
        myTree.getAlgNodeInfo(s2).treePredecessor=s5;
        myTree.getAlgNodeInfo(s3).treePredecessor=s1;
        myTree.getAlgNodeInfo(s4).treePredecessor=s1;
        myTree.getAlgNodeInfo(s5).treePredecessor=s7;
        myTree.getAlgNodeInfo(s6).treePredecessor=s2;
        myTree.getAlgNodeInfo(s7).treePredecessor=s2;
        myTree.getAlgNodeInfo(s1).predecessorLink=null;
        myTree.getAlgNodeInfo(s2).predecessorLink=y25;
        myTree.getAlgNodeInfo(s3).predecessorLink=y13;
        myTree.getAlgNodeInfo(s4).predecessorLink=y14;
        myTree.getAlgNodeInfo(s5).predecessorLink=y75;
        myTree.getAlgNodeInfo(s6).predecessorLink=y62;
        myTree.getAlgNodeInfo(s7).predecessorLink=y72;
        
        Node myNode;
        mySimplex.setTargetNetwork(map,true);
        try { myTree.checkTree();} 
        catch ( InvalidTreeException e1) {System.out.println("invalisd");}
        catch ( CyclicTreeException e2) {System.out.println("cycle");}
        catch (TreeHasManyRootsException e3){System.out.println("manyroot");}
        catch (TreeHasNoRootException e4) {System.out.println("noroot");}*/
                                            
        
        /*try { mySimplex.solve(factory); } catch (InfeasibleException e) {System.out.println("sdjfhjsdf");}
        mySimplex.setTargetNetwork(map2,false);
        try { mySimplex.solve(factory); } catch (InfeasibleException e) {System.out.println("sdjfhjsdf");}
        mySimplex.setTargetNetwork(map3,false);
        try { mySimplex.solve(factory); } catch (InfeasibleException e) {System.out.println("sdjfhjsdf");}
        for (int i=1;i<10;i++){};*/
     
        /*mySimplex.setTargetNetwork(map,false);
        mySimplex2.setTargetNetwork(map);
        mySimplex3.setTargetNetwork(map);
        try {mySimplex.solve(1e10,1e-3,4,2); } catch (InfeasibleException e) {System.out.println("Network Infeasible");}
        try {mySimplex2.solve(1e10,1e-3,4,3); } catch (InfeasibleException e) {System.out.println("Network Infeasible");}
        try {mySimplex3.solve(1e10,1e-3,4,3); } catch (InfeasibleException e) {System.out.println("Network Infeasible");}
        mySimplex.setTargetNetwork(map2,true);
        try {mySimplex2.solve(1e10,1e-3,4,3); } catch (InfeasibleException e) {System.out.println("Network Infeasible");}
        mySimplex.setTargetNetwork(map,true);
        try {mySimplex.solve(1e10,1e-3,4,3); } catch (InfeasibleException e) {System.out.println("Network Infeasible");}
        System.out.println("this is the end");
        */
        
        map.clean(null, null);
        map2.clean(null, null);
        map3.clean(null, null);
    }
}


class World implements Network {
    NetworkImplementation networkStuff;
    
    public World(){
        networkStuff=new NetworkImplementation();
    }
    
    public void clean(NodeFactory nodeFactory, ArcFactory arcFactory){
        networkStuff.clean(nodeFactory, arcFactory);
    }
    public int getNoOfNodes(){
        return networkStuff.getNoOfNodes();
    }
    public int getNoOfArcs() {
        return networkStuff.getNoOfArcs();
    }
    public int getNoOfAlgorithms(){
        return networkStuff.getNoOfAlgorithms();
    }
    public void setNoOfAlgorithms(int setNo){
        networkStuff.setNoOfAlgorithms(setNo);
    }
    public NodeList getNodeList(){
        return networkStuff.getNodeList();
    }
    public NodeList getNodeListEnd(){
        return networkStuff.getNodeListEnd();
    }
    public COM.objectspace.jgl.Array getAlgorithmList(){
        return networkStuff.getAlgorithmList();
    }
    public void addNode(Node addedNode){
        networkStuff.addNode(addedNode);
    }
    public void removeNode(Node deletedNode, NodeFactory nodeFactory, ArcFactory arcFactory){
        networkStuff.removeNode(deletedNode, nodeFactory, arcFactory);
    }
    public void addArc(Arc addedArc,Node fromNode, Node toNode){
        networkStuff.addArc(addedArc,fromNode,toNode);
    }
    public void removeArc(Arc deletedArc, ArcFactory arcFactory){
        networkStuff.removeArc(deletedArc, arcFactory);
    }
    public NodeList getNextNodeInList(NodeList currentPosition){
        return networkStuff.getNextNodeInList(currentPosition);
    }
    public NodeList getPreviousNodeInList(NodeList currentPosition){
        return networkStuff.getPreviousNodeInList(currentPosition);
    }
    
}


class City implements Node{
    int population;
    String name;
    NodeImplementation nodeStuff;
    
    City (String myName, double supply){
        name=myName;
        nodeStuff=new NodeImplementation();
        nodeStuff.setSupply(supply);
    }
    
    public void initializeNode(int nodeSupply){
        nodeStuff.initializeNode(nodeSupply);
    }
    public int getNoOfInBoundArcs(){
        return nodeStuff.getNoOfInBoundArcs();
    }
    public void addInBoundArc(Arc elem_){
        nodeStuff.addInBoundArc(elem_);
    }
    public void removeInBoundArc(Arc elem_){
        nodeStuff.removeInBoundArc(elem_);
    }
    public void cleanInBoundArcs(){
        nodeStuff.cleanInBoundArcs();
    }
    public int getNoOfOutBoundArcs(){
        return nodeStuff.getNoOfOutBoundArcs();
    }
    public void addOutBoundArc(Arc elem_){
        nodeStuff.addOutBoundArc(elem_);
    }
    public void removeOutBoundArc(Arc elem_){
        nodeStuff.removeOutBoundArc(elem_);
    }
    public void cleanOutBoundArcs(ArcFactory arcFactory){
        nodeStuff.cleanOutBoundArcs(arcFactory);
    }
    public void setNoOfOutBoundArcs(int setNumber){
        nodeStuff.setNoOfOutBoundArcs(setNumber);
    }
    public void setNoOfInBoundArcs(int setNumber){
        nodeStuff.setNoOfInBoundArcs(setNumber);
    }
    public ArcList getInBoundArcs(){
        return nodeStuff.getInBoundArcs();
    }
    public ArcList getOutBoundArcs(){
        return nodeStuff.getOutBoundArcs();
    }
    public Vector getNodeAlgorithmInfo(){
        return nodeStuff.getNodeAlgorithmInfo();
    }
    public void cleanNodeAlgorithmInfo(){
        nodeStuff.cleanNodeAlgorithmInfo();
    }
    
    public Network getContainerNetwork() {
        return nodeStuff.getContainerNetwork(); 
    }

    public void setContainerNetwork(Network setNetwork) {
        nodeStuff.setContainerNetwork(setNetwork);
    }

    
    public void setSupply(double mySupply){
        nodeStuff.setSupply(mySupply);
    }
    
    public double getSupply(){
        return nodeStuff.getSupply();
    }
    
    public String toString()
    {
        return (name + " = " + nodeStuff);
    }
    
    public void printNode(){
        System.out.println(name);
    }
}

class Road implements Arc{
    int maxSpeed;
    String name;
    ArcImplementation arcStuff;

    Road(double cost,double upperBound){
        arcStuff=new ArcImplementation(cost, upperBound);
    }
    
    public void initializeArc(double arcCost, double arcUpperBound){
        arcStuff.initializeArc(arcCost, arcUpperBound);
    }
    public void setTailNode(Node setNode){
        arcStuff.setTailNode(setNode);
    }
    public void setHeadNode(Node setNode){
        arcStuff.setHeadNode(setNode);
    }
    public Node getTailNode(){
        return arcStuff.getTailNode();
    }
    public Node getHeadNode(){
        return arcStuff.getHeadNode();
    }
    public Vector getArcAlgorithmInfo(){
        return arcStuff.getArcAlgorithmInfo();
    }
    public void cleanArcAlgorithmInfo(){
        arcStuff.cleanArcAlgorithmInfo();
    }
    public void printArc(){
        System.out.println(name);
    }
    public double getCost(){
        return arcStuff.getCost();
    }
    public void setCost(double setCost){
        arcStuff.setCost(setCost);
    }
    
    public double getUpperBound(){
        return arcStuff.getUpperBound();
    }
    
    public String toString()
    {
        return (name + ": " + arcStuff.getTailNode() + " -> " + arcStuff.getHeadNode());
    }
    
    public void setUpperBound(double ub) {
    }
    
    /*public void changeTailNode(Node newTailNode) {
        arcStuff.changeTailNode(newTailNode);
    }
    
    public void changeHeadNode(Node newHeadNode) {
        arcStuff.changeHeadNode(newHeadNode);
    }*/
    
}

