package Network.Representation;


import Network.Representation.*;

import java.util.*;

/** 
 * This interface serves as a template for arcs in a network. A default implementation is
 * given in class <code>ArcImplementation</code> and users are encouraged to use this class via subclassing
 * or delegating.
 */
public interface Arc {
    void initializeArc(double arcCost, double arcUpperBound);
    void setTailNode(Node setNode);
    void setHeadNode(Node setNode);
    Node getTailNode();
    Node getHeadNode();
    Vector getArcAlgorithmInfo();
    void cleanArcAlgorithmInfo();
    double getCost();
    void setCost(double setCost);
    double getUpperBound();
    void setUpperBound ( double ub );
}
