package Network.Representation;


public final class ArcListFactory {

    private ArcListStack stack;
    
    
    public ArcListFactory(int capacity_, int capacityIncrement_)
    {
        stack = new ArcListStack(capacity_, capacityIncrement_);
    }


    public final ArcList make(Arc elem_, ArcList next_)
    {
        ArcList arcList = stack.pop();
        if (arcList != null) {
            arcList.initialize(elem_, next_);
            return (arcList);
        }
        else
            return (new ArcList(elem_, next_));
    }
    
    public final ArcList make(Arc elem_)
    {
        ArcList arcList = stack.pop();
        if (arcList != null) {
            arcList.initialize(elem_);
            return (arcList);
        }
        else
            return (new ArcList(elem_));
    }

    public final void unmake(ArcList arcList)
    {
        stack.push(arcList);
    }

}
